Actor player;
ArrayList objects;
PFont helvetica;
int money = 0;
int soul = 100;
int salary = 100;
int raiseFactor = 3;
int selloutFactor = 20;
int gameState = 0;

void setup() {
  size (600, 96);
  objects = new ArrayList();
  helvetica = loadFont("Helvetica-48.vlw");
                                        // SIZE                 //POSITION
  player = new Actor("character.png", new PVector(27,49), new PVector(0, 0));
  player.player = true;

                                        // SIZE                 //POSITION
  objects.add(new Actor("chest.png", new PVector (30,30), new PVector(10, 50)));
  objects.add(new Actor("chest.png", new PVector (30,30), new PVector(500, 45)));
  objects.add(new Actor("chest.png", new PVector (30,30), new PVector(100, 10)));
  objects.add(new Actor("chest.png", new PVector (30,30), new PVector(300, 30)));
  objects.add(new Actor("chest.png", new PVector (30,30), new PVector(200, 70)));
}

void draw() {
  background(66);
  if (gameState == 0) {
    //HUD
    textFont(helvetica, 25);
  //  text("$" + money, 500, 80);
    text("Someday, I will be CEO\nof a big game company...\n(Press any key to play)", 0, 21);

  } else if (gameState == 1) {
    //
    //UPDATE
    if (soul <= 0) {
      gameState = 2;
    }
    player.update();

    for (int i = 0; i < objects.size(); i++) {
      Actor currentObject = (Actor)objects.get(i);
      currentObject.update();

      if (currentObject.collidesWith(player)){
        if (!currentObject.opened) {
          currentObject.opened = true;
          currentObject.switchSprite("chestOpen.png");
          currentObject.setPopupText("Rai$e!");
          salary *= raiseFactor;
          soul -= selloutFactor;
        }
      }
    } 

    //DRAW
    for (int i = 0; i < objects.size(); i++) {
      Actor currentObject = (Actor)objects.get(i);
      currentObject.draw();
    } 
    player.draw();

    //HUD
    textFont(helvetica, 12);
  //  text("$" + money, 500, 80);
    text("Salary $"  + salary, 500, 80);
    text("Soul "  + soul + "%", 500, 95);
  } else if (gameState == 2) {
    //HUD
    textFont(helvetica, 25);
  //  text("$" + money, 500, 80);
    text("Congratulations! You are now CEO\nof MegaGamesCorp International!\nYou are happy.", 0, 20);

    textFont(helvetica, 12);
    text("Salary $"  + salary, 500, 80);
    text("Soul "  + soul + "%", 500, 95);
  }
}

void keyPressed() {
 if (key == CODED) {
   if (keyCode == UP) {
     player.velocity.y = -1;
   } else if (keyCode == DOWN) {
     player.velocity.y = 1;
   } else if (keyCode == LEFT) {
     player.velocity.x = -1;
   } else if (keyCode == RIGHT) {
     player.velocity.x = 1;
   }
 } else {
   if (key == 'd') {
     println(mouseX + ", " + mouseY);
   }
 }

 if (gameState == 0) {
   gameState = 1;
 }
}

void keyReleased() {
 if (key == CODED) {
   if (keyCode == UP) {
     player.velocity.y = 0;
   } else if (keyCode == DOWN) {
     player.velocity.y = 0;
   } else if (keyCode == LEFT) {
     player.velocity.x = 0;
   } else if (keyCode == RIGHT) {
     player.velocity.x = 0;
   }
 }
}

